/*
 * Copyright (c) 2016, 2018 Oracle and/or its affiliates. All rights reserved. This
 * code is released under a tri EPL/GPL/LGPL license. You can use it,
 * redistribute it and/or modify it under the terms of the:
 *
 * Eclipse Public License version 1.0, or
 * GNU General Public License version 2, or
 * GNU Lesser General Public License version 2.1.
 */
package org.truffleruby.shared.options;

// This file is automatically generated by options.yml with 'jt build options'

import javax.annotation.Generated;

@Generated("tool/generate-options.rb")
public class OptionsCatalog {

    public static final StringOptionDescription HOME = new StringOptionDescription(
            "ruby.home",
            "The location of the TruffleRuby installation files",
            null,
            "");
    public static final BooleanOptionDescription NO_HOME_PROVIDED = new BooleanOptionDescription(
            "ruby.no_home_provided",
            "set to true to explicitly state that no home is provided (silences the warnings)",
            null,
            false);
    public static final StringOptionDescription LAUNCHER = new StringOptionDescription(
            "ruby.launcher",
            "The location of the TruffleRuby launcher program",
            null,
            "");
    public static final BooleanOptionDescription EMBEDDED = new BooleanOptionDescription(
            "ruby.embedded",
            "Set default options for an embedded use of TruffleRuby, rather than top-level use",
            null,
            true);
    public static final StringArrayOptionDescription LOAD_PATHS = new StringArrayOptionDescription(
            "ruby.load_paths",
            "Load paths (configured by -I Ruby options)",
            new String[]{"-I"},
            new String[]{});
    public static final StringArrayOptionDescription REQUIRED_LIBRARIES = new StringArrayOptionDescription(
            "ruby.required_libraries",
            "Required libraries (configured by -r Ruby options)",
            new String[]{"-r"},
            new String[]{});
    public static final BooleanOptionDescription READ_RUBYOPT = new BooleanOptionDescription(
            "ruby.read_rubyopt",
            "Read RUBYOPT and TRUFFLERUBYOPT environment variables",
            null,
            true);
    public static final BooleanOptionDescription IGNORE_LINES_BEFORE_RUBY_SHEBANG = new BooleanOptionDescription(
            "ruby.ignore_lines_before_ruby_shebang",
            "strip off text before #!ruby line (configured by -x Ruby options)",
            new String[]{"-x"},
            false);
    public static final StringOptionDescription WORKING_DIRECTORY = new StringOptionDescription(
            "ruby.working_directory",
            "Interpreter will switch to this directory (configured by -C Ruby options)",
            new String[]{"-C"},
            "");
    public static final ExecutionActionOptionDescription EXECUTION_ACTION = new ExecutionActionOptionDescription(
            "ruby.execution_action",
            "What should be done after context is created (configured by -e, -S Ruby options)",
            new String[]{"-e", "-S"},
            ExecutionAction.NONE);
    public static final StringOptionDescription TO_EXECUTE = new StringOptionDescription(
            "ruby.to_execute",
            "A thing to be executed: a file, inline script, etc. Used by execution_action when applicable. (configured by -e, -S Ruby options)",
            new String[]{"-e", "-S"},
            "");
    public static final DefaultExecutionActionOptionDescription DEFAULT_EXECUTION_ACTION = new DefaultExecutionActionOptionDescription(
            "ruby.default_execution_action",
            "What should be done when no action is set.",
            null,
            DefaultExecutionAction.IRB);
    public static final BooleanOptionDescription SYNTAX_CHECK = new BooleanOptionDescription(
            "ruby.syntax_check",
            "Do not execute just check syntax. (configured by -c Ruby options)",
            new String[]{"-c"},
            false);
    public static final BooleanOptionDescription SHOW_VERSION = new BooleanOptionDescription(
            "ruby.show_version",
            "Show version. (configured by --version Ruby options)",
            new String[]{"--version"},
            false);
    public static final BooleanOptionDescription SHOW_COPYRIGHT = new BooleanOptionDescription(
            "ruby.show_copyright",
            "Show copyright. (configured by --copyright Ruby options)",
            new String[]{"--copyright"},
            false);
    public static final ShowHelpOptionDescription SHOW_HELP = new ShowHelpOptionDescription(
            "ruby.show_help",
            "What help should be shown. (configured by -h, --help Ruby options)",
            new String[]{"-h", "--help"},
            ShowHelp.NONE);
    public static final BooleanOptionDescription DEBUG = new BooleanOptionDescription(
            "ruby.debug",
            "Debug (configured by -d Ruby options)",
            new String[]{"-d"},
            false);
    public static final VerbosityOptionDescription VERBOSITY = new VerbosityOptionDescription(
            "ruby.verbosity",
            "Verbosity (configured by -v, -w, -W, --verbose Ruby options)",
            new String[]{"-v", "-w", "-W", "--verbose"},
            Verbosity.FALSE);
    public static final BooleanOptionDescription ARGV_GLOBALS = new BooleanOptionDescription(
            "ruby.argv_globals",
            "Parse options in script argv into global variables. (configured by -s Ruby options)",
            new String[]{"-s"},
            false);
    public static final StringArrayOptionDescription ARGV_GLOBAL_VALUES = new StringArrayOptionDescription(
            "ruby.argv_global_values",
            "Parsed options from script argv with a value.",
            null,
            new String[]{});
    public static final StringArrayOptionDescription ARGV_GLOBAL_FLAGS = new StringArrayOptionDescription(
            "ruby.argv_global_flags",
            "Parsed options from script argv acting as flags (no value).",
            null,
            new String[]{});
    public static final BooleanOptionDescription DEFAULT_LAZY = new BooleanOptionDescription(
            "ruby.lazy.default",
            "Enable default lazy options",
            null,
            true);
    public static final BooleanOptionDescription HASHING_DETERMINISTIC = new BooleanOptionDescription(
            "ruby.hashing.deterministic",
            "Produce deterministic hash values",
            null,
            false);
    public static final BooleanOptionDescription FROZEN_STRING_LITERALS = new BooleanOptionDescription(
            "ruby.frozen_string_literals",
            "Use frozen string literals",
            null,
            false);
    public static final BooleanOptionDescription RUBYGEMS = new BooleanOptionDescription(
            "ruby.rubygems",
            "Use RubyGems",
            null,
            true);
    public static final BooleanOptionDescription LAZY_RUBYGEMS = new BooleanOptionDescription(
            "ruby.rubygems.lazy",
            "Load RubyGems lazily on first failing require",
            null,
            DEFAULT_LAZY.getDefaultValue());
    public static final BooleanOptionDescription PATCHING = new BooleanOptionDescription(
            "ruby.patching",
            "Use patching",
            null,
            true);
    public static final BooleanOptionDescription DID_YOU_MEAN = new BooleanOptionDescription(
            "ruby.did_you_mean",
            "Use did_you_mean",
            null,
            true);
    public static final StringOptionDescription SOURCE_ENCODING = new StringOptionDescription(
            "ruby.source_encoding",
            "Source encoding (configured by -K Ruby options)",
            new String[]{"-K"},
            "");
    public static final StringOptionDescription INTERNAL_ENCODING = new StringOptionDescription(
            "ruby.internal_encoding",
            "Internal encoding (configured by -E, -U Ruby options)",
            new String[]{"-E", "-U"},
            "");
    public static final StringOptionDescription EXTERNAL_ENCODING = new StringOptionDescription(
            "ruby.external_encoding",
            "External encoding (configured by -E Ruby options)",
            new String[]{"-E"},
            "");
    public static final BooleanOptionDescription NATIVE_PLATFORM = new BooleanOptionDescription(
            "ruby.platform.native",
            "Enables native calls via Truffle NFI for internal functionality",
            null,
            true);
    public static final BooleanOptionDescription NATIVE_INTERRUPT = new BooleanOptionDescription(
            "ruby.platform.native_interrupt",
            "Use the SIGVTALRM signal to interrupt native blocking calls",
            null,
            NATIVE_PLATFORM.getDefaultValue());
    public static final BooleanOptionDescription HANDLE_INTERRUPT = new BooleanOptionDescription(
            "ruby.platform.handle_interrupt",
            "Handle the interrupt signal and raise an Interrupt exception",
            null,
            !EMBEDDED.getDefaultValue());
    public static final BooleanOptionDescription SINGLE_THREADED = new BooleanOptionDescription(
            "ruby.single_threaded",
            "Use only a single thread to be compatible with languages not supporting multithreading",
            null,
            EMBEDDED.getDefaultValue());
    public static final BooleanOptionDescription POLYGLOT_STDIO = new BooleanOptionDescription(
            "ruby.polyglot.stdio",
            "Use standard IO streams from the Graal-SDK polyglot API configuration",
            null,
            EMBEDDED.getDefaultValue() || !NATIVE_PLATFORM.getDefaultValue());
    public static final BooleanOptionDescription CEXT_LOCK = new BooleanOptionDescription(
            "ruby.cexts.lock",
            "Use a Global Lock when running C extensions",
            null,
            true);
    public static final BooleanOptionDescription PREINITIALIZATION = new BooleanOptionDescription(
            "ruby.preinit",
            "Use the pre-initialized context when available",
            null,
            true);
    public static final BooleanOptionDescription TRACE_CALLS = new BooleanOptionDescription(
            "ruby.trace.calls",
            "Support tracing (set_trace_func, TracePoint) of method calls",
            null,
            true);
    public static final BooleanOptionDescription COVERAGE_GLOBAL = new BooleanOptionDescription(
            "ruby.coverage.global",
            "Run coverage for all code and print results on exit",
            null,
            false);
    public static final StringOptionDescription CORE_LOAD_PATH = new StringOptionDescription(
            "ruby.core.load_path",
            "Location to load the Truffle core library from",
            null,
            "resource:/truffleruby");
    public static final BooleanOptionDescription CORE_AS_INTERNAL = new BooleanOptionDescription(
            "ruby.core_as_internal",
            "Mark core library sources as internal",
            null,
            true);
    public static final BooleanOptionDescription STDLIB_AS_INTERNAL = new BooleanOptionDescription(
            "ruby.stdlib_as_internal",
            "Mark stdlib sources as internal",
            null,
            true);
    public static final BooleanOptionDescription LAZY_BUILTINS = new BooleanOptionDescription(
            "ruby.lazy_builtins",
            "Load builtin classes (core methods & primitives) lazily on first use",
            null,
            DEFAULT_LAZY.getDefaultValue());
    public static final BooleanOptionDescription LAZY_CORE_METHOD_NODES = new BooleanOptionDescription(
            "ruby.lazy_core_method_nodes",
            "Lazily create core method nodes",
            null,
            DEFAULT_LAZY.getDefaultValue());
    public static final BooleanOptionDescription LAZY_TRANSLATION_CORE = new BooleanOptionDescription(
            "ruby.lazy_translation.core",
            "Lazily translation of core source files",
            null,
            DEFAULT_LAZY.getDefaultValue());
    public static final BooleanOptionDescription LAZY_TRANSLATION_USER = new BooleanOptionDescription(
            "ruby.lazy_translation.user",
            "Lazily translation of stdlib, gem and user source files",
            null,
            false);
    public static final BooleanOptionDescription LAZY_TRANSLATION_LOG = new BooleanOptionDescription(
            "ruby.lazy_translation.log",
            "Log lazy translations from the parser AST to the Truffle AST",
            null,
            false);
    public static final IntegerOptionDescription ARRAY_UNINITIALIZED_SIZE = new IntegerOptionDescription(
            "ruby.array.uninitialized_size",
            "How large an Array to allocate when we have no other information to go on",
            null,
            16);
    public static final IntegerOptionDescription ARRAY_SMALL = new IntegerOptionDescription(
            "ruby.array.small",
            "Maximum size of an Array to consider small for optimisations",
            null,
            3);
    public static final IntegerOptionDescription HASH_PACKED_ARRAY_MAX = new IntegerOptionDescription(
            "ruby.hash.packed_array.max",
            "Maximum size of a Hash to consider using the packed array storage strategy for",
            null,
            3);
    public static final BooleanOptionDescription ROPE_LAZY_SUBSTRINGS = new BooleanOptionDescription(
            "ruby.rope.lazy_substrings",
            "Indicates whether a substring operation on a rope should be performed lazily",
            null,
            true);
    public static final BooleanOptionDescription ROPE_PRINT_INTERN_STATS = new BooleanOptionDescription(
            "ruby.rope.print_intern_stats",
            "Print interned rope stats at application exit",
            null,
            false);
    public static final IntegerOptionDescription ROPE_DEPTH_THRESHOLD = new IntegerOptionDescription(
            "ruby.rope.depth_threshold",
            "Threshold value at which ropes will be rebalanced (indirectly controls flattening as well)",
            null,
            128);
    public static final IntegerOptionDescription GLOBAL_VARIABLE_MAX_INVALIDATIONS = new IntegerOptionDescription(
            "ruby.global_variable.max_invalidations",
            "Maximum number of times a global variable can be changed to be considered constant",
            null,
            1);
    public static final IntegerOptionDescription DEFAULT_CACHE = new IntegerOptionDescription(
            "ruby.default_cache",
            "Default size for caches",
            null,
            8);
    public static final IntegerOptionDescription METHOD_LOOKUP_CACHE = new IntegerOptionDescription(
            "ruby.method_lookup.cache",
            "Method lookup cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription DISPATCH_CACHE = new IntegerOptionDescription(
            "ruby.dispatch.cache",
            "Dispatch (various forms of method call) cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription YIELD_CACHE = new IntegerOptionDescription(
            "ruby.yield.cache",
            "Yield cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription METHOD_TO_PROC_CACHE = new IntegerOptionDescription(
            "ruby.to_proc.cache",
            "Method#to_proc cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription IS_A_CACHE = new IntegerOptionDescription(
            "ruby.is_a.cache",
            "Kernel#is_a? and #kind_of? cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription BIND_CACHE = new IntegerOptionDescription(
            "ruby.bind.cache",
            "Cache size of test for being able to bind a method to a module",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription CONSTANT_CACHE = new IntegerOptionDescription(
            "ruby.constant.cache",
            "Constant cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription INSTANCE_VARIABLE_CACHE = new IntegerOptionDescription(
            "ruby.instance_variable.cache",
            "Instance variable cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription BINDING_LOCAL_VARIABLE_CACHE = new IntegerOptionDescription(
            "ruby.binding_local_variable.cache",
            "Binding#local_variable_get/set cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription SYMBOL_TO_PROC_CACHE = new IntegerOptionDescription(
            "ruby.symbol_to_proc.cache",
            "Symbol#to_proc cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription ALLOCATE_CLASS_CACHE = new IntegerOptionDescription(
            "ruby.allocate_class.cache",
            "Allocation size class cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription PACK_CACHE = new IntegerOptionDescription(
            "ruby.pack.cache",
            "Array#pack cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription UNPACK_CACHE = new IntegerOptionDescription(
            "ruby.unpack.cache",
            "String#unpack cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription EVAL_CACHE = new IntegerOptionDescription(
            "ruby.eval.cache",
            "eval cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription CLASS_CACHE = new IntegerOptionDescription(
            "ruby.class.cache",
            ".class and .metaclass cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription ENCODING_COMPATIBLE_QUERY_CACHE = new IntegerOptionDescription(
            "ruby.encoding_compatible_query.cache",
            "Encoding.compatible? cache size",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription ENCODING_LOADED_CLASSES_CACHE = new IntegerOptionDescription(
            "ruby.encoding_loaded_classes.cache",
            "Cache size of encoding operations based on anticipated number of total active encodings",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription THREAD_CACHE = new IntegerOptionDescription(
            "ruby.thread.cache",
            "Cache size of operations that depend on a particular thread",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription ROPE_CLASS_CACHE = new IntegerOptionDescription(
            "ruby.rope_class.cache",
            "Cache size for rope operations that depend on a concrete rope implementation to avoid virtual calls",
            null,
            8);
    public static final IntegerOptionDescription INTEROP_CONVERT_CACHE = new IntegerOptionDescription(
            "ruby.interop.convert.cache",
            "Cache size for converting values for interop",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription INTEROP_EXECUTE_CACHE = new IntegerOptionDescription(
            "ruby.interop.execute.cache",
            "Cache size for interop EXECUTE messages",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription INTEROP_INVOKE_CACHE = new IntegerOptionDescription(
            "ruby.interop.invoke.cache",
            "Cache size for interop INVOKE messages",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription INTEROP_NEW_CACHE = new IntegerOptionDescription(
            "ruby.interop.new.cache",
            "Cache size for interop NEW messages",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription TIME_FORMAT_CACHE = new IntegerOptionDescription(
            "ruby.time.format.cache",
            "Cache size for parsed time format specifiers",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription POW_CACHE = new IntegerOptionDescription(
            "ruby.integer.pow.cache",
            "Cache size for Integer#** with a constant exponent",
            null,
            DEFAULT_CACHE.getDefaultValue());
    public static final IntegerOptionDescription ARRAY_DUP_CACHE = new IntegerOptionDescription(
            "ruby.array.dup.cache",
            "Cache size for copying small arrays",
            null,
            3);
    public static final IntegerOptionDescription FRAME_VARIABLE_ACCESS_CACHE = new IntegerOptionDescription(
            "ruby.frame.variable.access.cache",
            "Cache size for accessing variables in another frame",
            null,
            5);
    public static final BooleanOptionDescription CLONE_DEFAULT = new BooleanOptionDescription(
            "ruby.clone.default",
            "Default option for cloning",
            null,
            true);
    public static final BooleanOptionDescription INLINE_DEFAULT = new BooleanOptionDescription(
            "ruby.inline.default",
            "Default option for inlining",
            null,
            true);
    public static final BooleanOptionDescription CORE_ALWAYS_CLONE = new BooleanOptionDescription(
            "ruby.core.always_clone",
            "Always clone built-in core methods",
            null,
            CLONE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription INLINE_NEEDS_CALLER_FRAME = new BooleanOptionDescription(
            "ruby.inline_needs_caller_frame",
            "Inline methods that need their caller frame",
            null,
            INLINE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription YIELD_ALWAYS_CLONE = new BooleanOptionDescription(
            "ruby.yield.always_clone",
            "Always clone yields",
            null,
            CLONE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription YIELD_ALWAYS_INLINE = new BooleanOptionDescription(
            "ruby.yield.always_inline",
            "Always inline yields",
            null,
            INLINE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription METHODMISSING_ALWAYS_CLONE = new BooleanOptionDescription(
            "ruby.method_missing.always_clone",
            "Always clone #method_missing",
            null,
            CLONE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription METHODMISSING_ALWAYS_INLINE = new BooleanOptionDescription(
            "ruby.method_missing.always_inline",
            "Always inline #method_missing",
            null,
            INLINE_DEFAULT.getDefaultValue());
    public static final BooleanOptionDescription CALL_WITH_BLOCK_ALWAYS_CLONE = new BooleanOptionDescription(
            "ruby.call_with_block.always_clone",
            "Always clone calls with a literal block",
            null,
            CLONE_DEFAULT.getDefaultValue());
    public static final IntegerOptionDescription PACK_UNROLL_LIMIT = new IntegerOptionDescription(
            "ruby.pack.unroll",
            "If a pack or unpack expression has a loop less than this many iterations, unroll it",
            null,
            4);
    public static final IntegerOptionDescription PACK_RECOVER_LOOP_MIN = new IntegerOptionDescription(
            "ruby.pack.recover",
            "If a pack or unpack expression is longer than this, attempt to recover loops",
            null,
            32);
    public static final BooleanOptionDescription EXCEPTIONS_STORE_JAVA = new BooleanOptionDescription(
            "ruby.exceptions.store_java",
            "Store the Java exception with the Ruby backtrace",
            null,
            false);
    public static final BooleanOptionDescription EXCEPTIONS_PRINT_JAVA = new BooleanOptionDescription(
            "ruby.exceptions.print_java",
            "Print Java exceptions at the point of translating them to Ruby exceptions",
            null,
            false);
    public static final BooleanOptionDescription EXCEPTIONS_PRINT_UNCAUGHT_JAVA = new BooleanOptionDescription(
            "ruby.exceptions.print_uncaught_java",
            "Print uncaught Java exceptions at the point of translating them to Ruby exceptions",
            null,
            false);
    public static final BooleanOptionDescription EXCEPTIONS_PRINT_RUBY_FOR_JAVA = new BooleanOptionDescription(
            "ruby.exceptions.print_ruby_for_java",
            "When printing a Java backtrace, also print the Ruby backtrace at that point",
            null,
            false);
    public static final BooleanOptionDescription EXCEPTIONS_TRANSLATE_ASSERT = new BooleanOptionDescription(
            "ruby.exceptions.translate_assert",
            "Translate failed Java assertions to Ruby exceptions",
            null,
            true);
    public static final BooleanOptionDescription EXCEPTIONS_WARN_STACKOVERFLOW = new BooleanOptionDescription(
            "ruby.exceptions.warn_stackoverflow",
            "Warn when a stack overflow error is thrown",
            null,
            true);
    public static final BooleanOptionDescription EXCEPTIONS_WARN_OUT_OF_MEMORY = new BooleanOptionDescription(
            "ruby.exceptions.warn_out_of_memory",
            "Warn when an out-of-memory error is thrown",
            null,
            true);
    public static final BooleanOptionDescription BACKTRACES_HIDE_CORE_FILES = new BooleanOptionDescription(
            "ruby.backtraces.hide_core_files",
            "Hide core source files in backtraces, like MRI does",
            null,
            true);
    public static final BooleanOptionDescription BACKTRACES_INTERLEAVE_JAVA = new BooleanOptionDescription(
            "ruby.backtraces.interleave_java",
            "Interleave Java stacktraces into the Ruby backtrace",
            null,
            false);
    public static final IntegerOptionDescription BACKTRACES_LIMIT = new IntegerOptionDescription(
            "ruby.backtraces.limit",
            "Limit the size of Ruby backtraces",
            null,
            9999);
    public static final BooleanOptionDescription BACKTRACES_OMIT_UNUSED = new BooleanOptionDescription(
            "ruby.backtraces.omit_unused",
            "Omit backtraces that should be unused as they have pure rescue expressions",
            null,
            true);
    public static final BooleanOptionDescription BACKTRACE_ON_INTERRUPT = new BooleanOptionDescription(
            "ruby.backtraces.on_interrupt",
            "Show the backtraces of all Threads on Ctrl+C",
            null,
            false);
    public static final BooleanOptionDescription BACKTRACE_ON_SIGALRM = new BooleanOptionDescription(
            "ruby.backtraces.sigalrm",
            "Show the backtraces of all Threads on SIGALRM",
            null,
            !EMBEDDED.getDefaultValue());
    public static final BooleanOptionDescription BACKTRACE_ON_RAISE = new BooleanOptionDescription(
            "ruby.backtraces.raise",
            "Show the backtraces of exceptions at the point of them being raised",
            null,
            false);
    public static final BooleanOptionDescription BASICOPS_INLINE = new BooleanOptionDescription(
            "ruby.basic_ops.inline",
            "Inline basic operations (like Fixnum operators) in the AST without a call",
            null,
            true);
    public static final BooleanOptionDescription REGEXP_INSTRUMENT_CREATION = new BooleanOptionDescription(
            "ruby.regexp.instrument-creation",
            "Enable instrumentation to gather stats on regexp creation.",
            null,
            false);
    public static final BooleanOptionDescription REGEXP_INSTRUMENT_MATCH = new BooleanOptionDescription(
            "ruby.regexp.instrument-match",
            "Enable instrumentation to gather stats on regexp matching.",
            null,
            false);
    public static final BooleanOptionDescription SHARED_OBJECTS_ENABLED = new BooleanOptionDescription(
            "ruby.shared.objects",
            "Enable shared objects",
            null,
            true);
    public static final BooleanOptionDescription SHARED_OBJECTS_DEBUG = new BooleanOptionDescription(
            "ruby.shared.objects.debug",
            "Print information about shared objects",
            null,
            false);
    public static final BooleanOptionDescription SHARED_OBJECTS_FORCE = new BooleanOptionDescription(
            "ruby.shared.objects.force",
            "Force sharing of objects roots at startup",
            null,
            false);
    public static final BooleanOptionDescription SHARED_OBJECTS_SHARE_ALL = new BooleanOptionDescription(
            "ruby.shared.objects.share_all",
            "Consider all objects as shared",
            null,
            false);
    public static final BooleanOptionDescription CEXTS = new BooleanOptionDescription(
            "ruby.cexts",
            "Enable use of C extensions",
            null,
            true);
    public static final BooleanOptionDescription CEXTS_LOG_LOAD = new BooleanOptionDescription(
            "ruby.cexts.log.load",
            "Log loading of cexts",
            null,
            false);
    public static final BooleanOptionDescription CEXTS_LOG_WARNINGS = new BooleanOptionDescription(
            "ruby.cexts.log.warnings",
            "Log cexts warnings",
            null,
            false);
    public static final StringArrayOptionDescription CEXTS_LIBRARY_REMAP = new StringArrayOptionDescription(
            "ruby.cexts.remap",
            "Remap the name of native libraries, written in the form libexample.so:/path/to/actual/libexample.so",
            null,
            new String[]{});
    public static final BooleanOptionDescription LOG_DYNAMIC_CONSTANT_LOOKUP = new BooleanOptionDescription(
            "ruby.constant.dynamic_lookup.log",
            "Log source code positions where dynamic constant lookup is performed",
            null,
            false);
    public static final BooleanOptionDescription OPTIONS_LOG = new BooleanOptionDescription(
            "ruby.options.log",
            "Log the final value of all options",
            null,
            false);
    public static final BooleanOptionDescription LOG_LOAD = new BooleanOptionDescription(
            "ruby.log.load",
            "Log loading files",
            null,
            false);
    public static final BooleanOptionDescription LOG_FEATURE_LOCATION = new BooleanOptionDescription(
            "ruby.log.feature_location",
            "Log the process of finding features",
            null,
            false);
    public static final BooleanOptionDescription METRICS_TIME_PARSING_FILE = new BooleanOptionDescription(
            "ruby.metrics.time.parsing.file",
            "Measure time for parsing, translating and executing files, per file",
            null,
            false);
    public static final BooleanOptionDescription METRICS_TIME_REQUIRE = new BooleanOptionDescription(
            "ruby.metrics.time.require",
            "Measure time for #require and executing the required file",
            null,
            false);
    
    public static OptionDescription<?> fromName(String name) {
        switch (name) {
            case "ruby.home":
                return HOME;
            case "ruby.no_home_provided":
                return NO_HOME_PROVIDED;
            case "ruby.launcher":
                return LAUNCHER;
            case "ruby.embedded":
                return EMBEDDED;
            case "ruby.load_paths":
                return LOAD_PATHS;
            case "ruby.required_libraries":
                return REQUIRED_LIBRARIES;
            case "ruby.read_rubyopt":
                return READ_RUBYOPT;
            case "ruby.ignore_lines_before_ruby_shebang":
                return IGNORE_LINES_BEFORE_RUBY_SHEBANG;
            case "ruby.working_directory":
                return WORKING_DIRECTORY;
            case "ruby.execution_action":
                return EXECUTION_ACTION;
            case "ruby.to_execute":
                return TO_EXECUTE;
            case "ruby.default_execution_action":
                return DEFAULT_EXECUTION_ACTION;
            case "ruby.syntax_check":
                return SYNTAX_CHECK;
            case "ruby.show_version":
                return SHOW_VERSION;
            case "ruby.show_copyright":
                return SHOW_COPYRIGHT;
            case "ruby.show_help":
                return SHOW_HELP;
            case "ruby.debug":
                return DEBUG;
            case "ruby.verbosity":
                return VERBOSITY;
            case "ruby.argv_globals":
                return ARGV_GLOBALS;
            case "ruby.argv_global_values":
                return ARGV_GLOBAL_VALUES;
            case "ruby.argv_global_flags":
                return ARGV_GLOBAL_FLAGS;
            case "ruby.lazy.default":
                return DEFAULT_LAZY;
            case "ruby.hashing.deterministic":
                return HASHING_DETERMINISTIC;
            case "ruby.frozen_string_literals":
                return FROZEN_STRING_LITERALS;
            case "ruby.rubygems":
                return RUBYGEMS;
            case "ruby.rubygems.lazy":
                return LAZY_RUBYGEMS;
            case "ruby.patching":
                return PATCHING;
            case "ruby.did_you_mean":
                return DID_YOU_MEAN;
            case "ruby.source_encoding":
                return SOURCE_ENCODING;
            case "ruby.internal_encoding":
                return INTERNAL_ENCODING;
            case "ruby.external_encoding":
                return EXTERNAL_ENCODING;
            case "ruby.platform.native":
                return NATIVE_PLATFORM;
            case "ruby.platform.native_interrupt":
                return NATIVE_INTERRUPT;
            case "ruby.platform.handle_interrupt":
                return HANDLE_INTERRUPT;
            case "ruby.single_threaded":
                return SINGLE_THREADED;
            case "ruby.polyglot.stdio":
                return POLYGLOT_STDIO;
            case "ruby.cexts.lock":
                return CEXT_LOCK;
            case "ruby.preinit":
                return PREINITIALIZATION;
            case "ruby.trace.calls":
                return TRACE_CALLS;
            case "ruby.coverage.global":
                return COVERAGE_GLOBAL;
            case "ruby.core.load_path":
                return CORE_LOAD_PATH;
            case "ruby.core_as_internal":
                return CORE_AS_INTERNAL;
            case "ruby.stdlib_as_internal":
                return STDLIB_AS_INTERNAL;
            case "ruby.lazy_builtins":
                return LAZY_BUILTINS;
            case "ruby.lazy_core_method_nodes":
                return LAZY_CORE_METHOD_NODES;
            case "ruby.lazy_translation.core":
                return LAZY_TRANSLATION_CORE;
            case "ruby.lazy_translation.user":
                return LAZY_TRANSLATION_USER;
            case "ruby.lazy_translation.log":
                return LAZY_TRANSLATION_LOG;
            case "ruby.array.uninitialized_size":
                return ARRAY_UNINITIALIZED_SIZE;
            case "ruby.array.small":
                return ARRAY_SMALL;
            case "ruby.hash.packed_array.max":
                return HASH_PACKED_ARRAY_MAX;
            case "ruby.rope.lazy_substrings":
                return ROPE_LAZY_SUBSTRINGS;
            case "ruby.rope.print_intern_stats":
                return ROPE_PRINT_INTERN_STATS;
            case "ruby.rope.depth_threshold":
                return ROPE_DEPTH_THRESHOLD;
            case "ruby.global_variable.max_invalidations":
                return GLOBAL_VARIABLE_MAX_INVALIDATIONS;
            case "ruby.default_cache":
                return DEFAULT_CACHE;
            case "ruby.method_lookup.cache":
                return METHOD_LOOKUP_CACHE;
            case "ruby.dispatch.cache":
                return DISPATCH_CACHE;
            case "ruby.yield.cache":
                return YIELD_CACHE;
            case "ruby.to_proc.cache":
                return METHOD_TO_PROC_CACHE;
            case "ruby.is_a.cache":
                return IS_A_CACHE;
            case "ruby.bind.cache":
                return BIND_CACHE;
            case "ruby.constant.cache":
                return CONSTANT_CACHE;
            case "ruby.instance_variable.cache":
                return INSTANCE_VARIABLE_CACHE;
            case "ruby.binding_local_variable.cache":
                return BINDING_LOCAL_VARIABLE_CACHE;
            case "ruby.symbol_to_proc.cache":
                return SYMBOL_TO_PROC_CACHE;
            case "ruby.allocate_class.cache":
                return ALLOCATE_CLASS_CACHE;
            case "ruby.pack.cache":
                return PACK_CACHE;
            case "ruby.unpack.cache":
                return UNPACK_CACHE;
            case "ruby.eval.cache":
                return EVAL_CACHE;
            case "ruby.class.cache":
                return CLASS_CACHE;
            case "ruby.encoding_compatible_query.cache":
                return ENCODING_COMPATIBLE_QUERY_CACHE;
            case "ruby.encoding_loaded_classes.cache":
                return ENCODING_LOADED_CLASSES_CACHE;
            case "ruby.thread.cache":
                return THREAD_CACHE;
            case "ruby.rope_class.cache":
                return ROPE_CLASS_CACHE;
            case "ruby.interop.convert.cache":
                return INTEROP_CONVERT_CACHE;
            case "ruby.interop.execute.cache":
                return INTEROP_EXECUTE_CACHE;
            case "ruby.interop.invoke.cache":
                return INTEROP_INVOKE_CACHE;
            case "ruby.interop.new.cache":
                return INTEROP_NEW_CACHE;
            case "ruby.time.format.cache":
                return TIME_FORMAT_CACHE;
            case "ruby.integer.pow.cache":
                return POW_CACHE;
            case "ruby.array.dup.cache":
                return ARRAY_DUP_CACHE;
            case "ruby.frame.variable.access.cache":
                return FRAME_VARIABLE_ACCESS_CACHE;
            case "ruby.clone.default":
                return CLONE_DEFAULT;
            case "ruby.inline.default":
                return INLINE_DEFAULT;
            case "ruby.core.always_clone":
                return CORE_ALWAYS_CLONE;
            case "ruby.inline_needs_caller_frame":
                return INLINE_NEEDS_CALLER_FRAME;
            case "ruby.yield.always_clone":
                return YIELD_ALWAYS_CLONE;
            case "ruby.yield.always_inline":
                return YIELD_ALWAYS_INLINE;
            case "ruby.method_missing.always_clone":
                return METHODMISSING_ALWAYS_CLONE;
            case "ruby.method_missing.always_inline":
                return METHODMISSING_ALWAYS_INLINE;
            case "ruby.call_with_block.always_clone":
                return CALL_WITH_BLOCK_ALWAYS_CLONE;
            case "ruby.pack.unroll":
                return PACK_UNROLL_LIMIT;
            case "ruby.pack.recover":
                return PACK_RECOVER_LOOP_MIN;
            case "ruby.exceptions.store_java":
                return EXCEPTIONS_STORE_JAVA;
            case "ruby.exceptions.print_java":
                return EXCEPTIONS_PRINT_JAVA;
            case "ruby.exceptions.print_uncaught_java":
                return EXCEPTIONS_PRINT_UNCAUGHT_JAVA;
            case "ruby.exceptions.print_ruby_for_java":
                return EXCEPTIONS_PRINT_RUBY_FOR_JAVA;
            case "ruby.exceptions.translate_assert":
                return EXCEPTIONS_TRANSLATE_ASSERT;
            case "ruby.exceptions.warn_stackoverflow":
                return EXCEPTIONS_WARN_STACKOVERFLOW;
            case "ruby.exceptions.warn_out_of_memory":
                return EXCEPTIONS_WARN_OUT_OF_MEMORY;
            case "ruby.backtraces.hide_core_files":
                return BACKTRACES_HIDE_CORE_FILES;
            case "ruby.backtraces.interleave_java":
                return BACKTRACES_INTERLEAVE_JAVA;
            case "ruby.backtraces.limit":
                return BACKTRACES_LIMIT;
            case "ruby.backtraces.omit_unused":
                return BACKTRACES_OMIT_UNUSED;
            case "ruby.backtraces.on_interrupt":
                return BACKTRACE_ON_INTERRUPT;
            case "ruby.backtraces.sigalrm":
                return BACKTRACE_ON_SIGALRM;
            case "ruby.backtraces.raise":
                return BACKTRACE_ON_RAISE;
            case "ruby.basic_ops.inline":
                return BASICOPS_INLINE;
            case "ruby.regexp.instrument-creation":
                return REGEXP_INSTRUMENT_CREATION;
            case "ruby.regexp.instrument-match":
                return REGEXP_INSTRUMENT_MATCH;
            case "ruby.shared.objects":
                return SHARED_OBJECTS_ENABLED;
            case "ruby.shared.objects.debug":
                return SHARED_OBJECTS_DEBUG;
            case "ruby.shared.objects.force":
                return SHARED_OBJECTS_FORCE;
            case "ruby.shared.objects.share_all":
                return SHARED_OBJECTS_SHARE_ALL;
            case "ruby.cexts":
                return CEXTS;
            case "ruby.cexts.log.load":
                return CEXTS_LOG_LOAD;
            case "ruby.cexts.log.warnings":
                return CEXTS_LOG_WARNINGS;
            case "ruby.cexts.remap":
                return CEXTS_LIBRARY_REMAP;
            case "ruby.constant.dynamic_lookup.log":
                return LOG_DYNAMIC_CONSTANT_LOOKUP;
            case "ruby.options.log":
                return OPTIONS_LOG;
            case "ruby.log.load":
                return LOG_LOAD;
            case "ruby.log.feature_location":
                return LOG_FEATURE_LOCATION;
            case "ruby.metrics.time.parsing.file":
                return METRICS_TIME_PARSING_FILE;
            case "ruby.metrics.time.require":
                return METRICS_TIME_REQUIRE;
            default:
                return null;
        }
    }

    public static OptionDescription<?>[] allDescriptions() {
        return new OptionDescription<?>[] {
            ALLOCATE_CLASS_CACHE,
            ARGV_GLOBAL_FLAGS,
            ARGV_GLOBAL_VALUES,
            ARGV_GLOBALS,
            ARRAY_DUP_CACHE,
            ARRAY_SMALL,
            ARRAY_UNINITIALIZED_SIZE,
            BACKTRACES_HIDE_CORE_FILES,
            BACKTRACES_INTERLEAVE_JAVA,
            BACKTRACES_LIMIT,
            BACKTRACES_OMIT_UNUSED,
            BACKTRACE_ON_INTERRUPT,
            BACKTRACE_ON_RAISE,
            BACKTRACE_ON_SIGALRM,
            BASICOPS_INLINE,
            BIND_CACHE,
            BINDING_LOCAL_VARIABLE_CACHE,
            CALL_WITH_BLOCK_ALWAYS_CLONE,
            CEXTS,
            CEXT_LOCK,
            CEXTS_LOG_LOAD,
            CEXTS_LOG_WARNINGS,
            CEXTS_LIBRARY_REMAP,
            CLASS_CACHE,
            CLONE_DEFAULT,
            CONSTANT_CACHE,
            LOG_DYNAMIC_CONSTANT_LOOKUP,
            CORE_ALWAYS_CLONE,
            CORE_LOAD_PATH,
            CORE_AS_INTERNAL,
            COVERAGE_GLOBAL,
            DEBUG,
            DEFAULT_CACHE,
            DEFAULT_EXECUTION_ACTION,
            DID_YOU_MEAN,
            DISPATCH_CACHE,
            EMBEDDED,
            ENCODING_COMPATIBLE_QUERY_CACHE,
            ENCODING_LOADED_CLASSES_CACHE,
            EVAL_CACHE,
            EXCEPTIONS_PRINT_JAVA,
            EXCEPTIONS_PRINT_RUBY_FOR_JAVA,
            EXCEPTIONS_PRINT_UNCAUGHT_JAVA,
            EXCEPTIONS_STORE_JAVA,
            EXCEPTIONS_TRANSLATE_ASSERT,
            EXCEPTIONS_WARN_OUT_OF_MEMORY,
            EXCEPTIONS_WARN_STACKOVERFLOW,
            EXECUTION_ACTION,
            EXTERNAL_ENCODING,
            FRAME_VARIABLE_ACCESS_CACHE,
            FROZEN_STRING_LITERALS,
            GLOBAL_VARIABLE_MAX_INVALIDATIONS,
            HASH_PACKED_ARRAY_MAX,
            HASHING_DETERMINISTIC,
            HOME,
            IGNORE_LINES_BEFORE_RUBY_SHEBANG,
            INLINE_DEFAULT,
            INLINE_NEEDS_CALLER_FRAME,
            INSTANCE_VARIABLE_CACHE,
            POW_CACHE,
            INTERNAL_ENCODING,
            INTEROP_CONVERT_CACHE,
            INTEROP_EXECUTE_CACHE,
            INTEROP_INVOKE_CACHE,
            INTEROP_NEW_CACHE,
            IS_A_CACHE,
            LAUNCHER,
            DEFAULT_LAZY,
            LAZY_BUILTINS,
            LAZY_CORE_METHOD_NODES,
            LAZY_TRANSLATION_CORE,
            LAZY_TRANSLATION_LOG,
            LAZY_TRANSLATION_USER,
            LOAD_PATHS,
            LOG_FEATURE_LOCATION,
            LOG_LOAD,
            METHOD_LOOKUP_CACHE,
            METHODMISSING_ALWAYS_CLONE,
            METHODMISSING_ALWAYS_INLINE,
            METRICS_TIME_PARSING_FILE,
            METRICS_TIME_REQUIRE,
            NO_HOME_PROVIDED,
            OPTIONS_LOG,
            PACK_CACHE,
            PACK_RECOVER_LOOP_MIN,
            PACK_UNROLL_LIMIT,
            PATCHING,
            HANDLE_INTERRUPT,
            NATIVE_PLATFORM,
            NATIVE_INTERRUPT,
            POLYGLOT_STDIO,
            PREINITIALIZATION,
            READ_RUBYOPT,
            REGEXP_INSTRUMENT_CREATION,
            REGEXP_INSTRUMENT_MATCH,
            REQUIRED_LIBRARIES,
            ROPE_DEPTH_THRESHOLD,
            ROPE_LAZY_SUBSTRINGS,
            ROPE_PRINT_INTERN_STATS,
            ROPE_CLASS_CACHE,
            RUBYGEMS,
            LAZY_RUBYGEMS,
            SHARED_OBJECTS_ENABLED,
            SHARED_OBJECTS_DEBUG,
            SHARED_OBJECTS_FORCE,
            SHARED_OBJECTS_SHARE_ALL,
            SHOW_COPYRIGHT,
            SHOW_HELP,
            SHOW_VERSION,
            SINGLE_THREADED,
            SOURCE_ENCODING,
            STDLIB_AS_INTERNAL,
            SYMBOL_TO_PROC_CACHE,
            SYNTAX_CHECK,
            THREAD_CACHE,
            TIME_FORMAT_CACHE,
            TO_EXECUTE,
            METHOD_TO_PROC_CACHE,
            TRACE_CALLS,
            UNPACK_CACHE,
            VERBOSITY,
            WORKING_DIRECTORY,
            YIELD_ALWAYS_CLONE,
            YIELD_ALWAYS_INLINE,
            YIELD_CACHE,
        };
    }

}
